"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_native_1 = require("react-native");
var geolocation_1 = require("@react-native-community/geolocation");
var Qs = require("qs");
/** Class containing methods to get results from Google Places */
// TODO: add nearby search without input
var GPlaces = /** @class */ (function () {
    /**
     * Create an instance of the GPlaces class.
     * @param   {Options} [options=]
     *          Options for creating the handler
     */
    // TODO: give error if no key
    function GPlaces(options) {
        var _this = this;
        /**
         * Make a request expecting a JSON response
         * @param   {string} [url='']
         *          Request URL for Google Maps
         * @private
         */
        this.request = function (url) {
            if (url === void 0) { url = ''; }
            return new Promise(function (resolve, reject) {
                if (!url || typeof url !== 'string') {
                    reject(new Error('Invalid request URL.'));
                }
                fetch(url)
                    .then(function (r) { return r.json(); })
                    .then(resolve)
                    .catch(reject);
            });
        };
        /**
         * Search for places using specified options
         * @param   {string} [options='']
         *          Options string for the API call
         * @returns {Promise<ACResults>}
         *          Returns an unaltered array of results from the Google Places API
         */
        this.autocompleteRequest = function (options) {
            if (options === void 0) { options = ''; }
            return new Promise(function (resolve, reject) {
                _this.request("https://maps.googleapis.com/maps/api/place/autocomplete/json?" + options)
                    .then(function (res) {
                    if (!res || !res.predictions || !Array.isArray(res.predictions)) {
                        return reject(new Error('Invalid response from server'));
                    }
                    resolve(res.predictions);
                })
                    .catch(reject);
            });
        };
        /**
         * Search for places matching input
         * @param   {string} [input='']
         *          Input string for the search
         * @param   {ACQuery} [query=]
         *          Query object for the search
         * @returns {Promise<ACResults>}
         *          Returns an unaltered array of results from the Google Places API
         */
        this.search = function (input, query) {
            if (input === void 0) { input = ''; }
            return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                var options;
                return __generator(this, function (_a) {
                    if (!input || typeof input !== 'string') {
                        reject(new Error('Invalid input string given.'));
                    }
                    options = Qs.stringify(__assign({ input: input, language: 'en', key: this.options.key, types: 'establishment' }, query));
                    this.autocompleteRequest(options)
                        .then(resolve)
                        .catch(reject);
                    return [2 /*return*/];
                });
            }); });
        };
        /**
         * Search for places matching input
         * @param   {string} [input='']
         *          Input string for the search
         * @param   {number} [radius=1000]
         *          Radius in meters to look for places
         * @param   {ACQuery} [query=]
         *          Query object for the search
         * @returns {Promise<ACResults>}
         *          Returns an unaltered array of results from the Google Places API
         */
        this.searchNearby = function (input, radius, query) {
            if (input === void 0) { input = ''; }
            if (radius === void 0) { radius = 1000; }
            return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    geolocation_1.default.getCurrentPosition(function (position) { return __awaiter(_this, void 0, void 0, function () {
                        var _a, _b, latitude, _c, longitude, options;
                        return __generator(this, function (_d) {
                            _a = (position || { coords: null, timestamp: null }).coords || {}, _b = _a.latitude, latitude = _b === void 0 ? 0 : _b, _c = _a.longitude, longitude = _c === void 0 ? 0 : _c;
                            if (!latitude || !longitude) {
                                reject(new Error('No latitude/longtitude for current location found.'));
                            }
                            if (!input || typeof input !== 'string') {
                                reject(new Error('Invalid input string given.'));
                            }
                            if (!radius || typeof radius !== 'number') {
                                reject(new Error('Invalid radius given.'));
                            }
                            options = Qs.stringify(__assign({ input: input,
                                radius: radius, language: 'en', key: this.options.key, types: 'establishment', strictbounds: true, location: latitude + "," + longitude }, query));
                            this.autocompleteRequest(options)
                                .then(resolve)
                                .catch(reject);
                            return [2 /*return*/];
                        });
                    }); }, reject, {
                        enableHighAccuracy: react_native_1.Platform.OS === 'android',
                        timeout: 10000,
                        maximumAge: 1000
                    });
                    return [2 /*return*/];
                });
            }); });
        };
        /**
         * Search for places matching input
         * @param   {string} [placeid='']
         *          Place ID string of the requested place
         * @param   {PDQuery} [query=]
         *          Place ID string of the requested place
         * @returns {Promise<PDResult>}
         *          Returns an unaltered result object from the Google Places API
         */
        this.getPlaceDetails = function (placeid, query) {
            if (placeid === void 0) { placeid = ''; }
            return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                var options;
                return __generator(this, function (_a) {
                    if (!placeid || typeof placeid !== 'string') {
                        reject(new Error('Invalid Place ID string given.'));
                    }
                    options = Qs.stringify(__assign({ placeid: placeid, language: 'en', fields: 'geometry', key: this.options.key }, query));
                    this.request("https://maps.googleapis.com/maps/api/place/details/json?" + options)
                        .then(function (res) {
                        if (!res || !res.result || (typeof res !== 'object')) {
                            return reject(new Error('Invalid response from server'));
                        }
                        resolve(res.result);
                    })
                        .catch(reject);
                    return [2 /*return*/];
                });
            }); });
        };
        if (!options) {
            this.options = { key: '' };
        }
        else {
            this.options = options;
        }
    }
    return GPlaces;
}());
exports.default = GPlaces;
